package eu.eudat.file.transformer.entities.descriptiontemplate.fielddata;

import eu.eudat.file.transformer.enums.FieldDataComboBoxType;
import eu.eudat.file.transformer.enums.FieldType;
import eu.eudat.file.transformer.model.descriptiontemplatedefinition.fielddata.ComboBoxOption;
import eu.eudat.file.transformer.model.descriptiontemplatedefinition.fielddata.WordListData;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.LinkedList;
import java.util.List;

public class WordListDataEntity extends ComboBoxDataEntity<WordListDataEntity, WordListData> {
    private List<Option> options;
    
    private Boolean multiList;

    public List<Option> getOptions() {
        return options;
    }

    public void setOptions(List<Option> options) {
        this.options = options;
    }

    public Boolean getMultiList() {
        return multiList;
    }

    public void setMultiList(Boolean multiList) {
        this.multiList = multiList;
    }

    @Override
    public FieldDataComboBoxType getFieldSubType() {
        return FieldDataComboBoxType.Wordlist;
    }

    @Override
    public FieldType getFieldType() {
        return FieldType.WORD_LIST;
    }

    /*@Override
    public Element toXml(Document doc) {
        Element root = super.toXml(doc);
        root.setAttribute("multiList", this.multiList != null ? this.multiList.toString() : "false");
        Element element = doc.createElement("options");
        if (this.options != null) {
            for (Option option : this.options) {
                element.appendChild(option.toXml(doc));
            }
        }
        root.appendChild(element);
        return root;
    }

    @Override
    public WordListDataEntity fromXml(Element item) {
        super.fromXml(item);
        this.options = new LinkedList<>();
        Element optionsElement = (Element) item.getElementsByTagName("options").item(0);

        if (optionsElement != null) {
            NodeList optionElements = optionsElement.getChildNodes();
            for (int temp = 0; temp < optionElements.getLength(); temp++) {
                Node optionElement = optionElements.item(temp);
                if (optionElement.getNodeType() == Node.ELEMENT_NODE) {
                    this.options.add(new Option().fromXml((Element) optionElement));
                }
            }
        }
        Boolean temp = Boolean.parseBoolean(item.getAttribute("multiList"));
        this.multiList = temp != null ? temp : false;
        return this;
    }*/

    @Override
    public WordListDataEntity fromDefinition(WordListData object) {
        super.fromDefinition(object);
        this.options = new LinkedList<>();

        if (object.getOptions() != null) {
            for (ComboBoxOption option: object.getOptions()) {
                this.options.add(new Option().fromDefinition(option));
            }
        }
        Boolean temp = object.getMultiList();
        this.multiList = temp != null ? temp : false;
        return this;
    }
}
