package eu.eudat.file.transformer.enums;

import com.fasterxml.jackson.annotation.JsonValue;
import jakarta.xml.bind.annotation.XmlEnumValue;

import java.util.Map;

public enum ReferenceTypeSourceType implements DatabaseEnum<Short> {
	@XmlEnumValue(value = "0")
	API((short) 0),
	@XmlEnumValue(value = "1")
	STATIC((short) 1);
	private final Short value;

	public static class Names {
		public static final String API = "api";
		public static final String STATIC = "static";
	}

	ReferenceTypeSourceType(Short value) {
		this.value = value;
	}

	@JsonValue
	public Short getValue() {
		return value;
	}

	private static final Map<Short, ReferenceTypeSourceType> map = EnumUtils.getEnumValueMap(ReferenceTypeSourceType.class);

	public static ReferenceTypeSourceType of(Short i) {
		return map.get(i);
	}
}
