package eu.eudat.file.transformer.executor;

import eu.eudat.file.transformer.model.DescriptionFileTransformerModel;
import eu.eudat.file.transformer.model.DmpFileTransformerModel;
import eu.eudat.file.transformer.model.ExtraPropertiesModel;
import eu.eudat.file.transformer.model.file.FileEnvelope;

import javax.management.InvalidApplicationException;
import java.io.IOException;
import java.util.List;

public interface FileTransformerExecutor {
    FileEnvelope exportDmp(DmpFileTransformerModel dmp, ExtraPropertiesModel properties) throws InvalidApplicationException, IOException;
    FileEnvelope exportDescription(DescriptionFileTransformerModel descriptionFileTransformerModel, ExtraPropertiesModel properties) throws InvalidApplicationException, IOException;

    DmpFileTransformerModel importFileToDmp(FileEnvelope envelope);

    DescriptionFileTransformerModel importFileToDescription(FileEnvelope envelope);

    List<String> getSupportedFileFormats();
}
