package eu.eudat.file.transformer.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import eu.eudat.file.transformer.enums.IsActive;
import eu.eudat.file.transformer.enums.ReferenceSourceType;
import eu.eudat.file.transformer.enums.ReferenceType;
import eu.eudat.file.transformer.model.referencedefinition.Definition;

import java.time.Instant;
import java.util.List;
import java.util.UUID;

@JsonIgnoreProperties(ignoreUnknown = true)
public class Reference {

    private UUID id;
    public static final String _id = "id";

    private String label;
    public static final String _label = "label";

    private eu.eudat.file.transformer.enums.ReferenceType type;
    public static final String _type = "type";

    private String description;
    public static final String _description = "description";

    private Definition definition;
    public static final String _definition = "definition";

    private String reference;
    public static final String _reference = "reference";

    private String abbreviation;
    public static final String _abbreviation = "abbreviation";

    private String source;
    public static final String _source = "source";

    private ReferenceSourceType sourceType;
    public static final String _sourceType = "sourceType";

    private IsActive isActive;
    public static final String _isActive = "isActive";

    private Instant createdAt;
    public static final String _createdAt = "createdAt";

    private Instant updatedAt;
    public static final String _updatedAt = "updatedAt";

    private UserFileModel createdBy;
    public static final String _createdBy = "createdBy";

    private List<DmpReference> dmpReferences;
    public static final String _dmpReferences = "dmpReferences";

    private String hash;
    public final static String _hash = "hash";

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public eu.eudat.file.transformer.enums.ReferenceType getType() {
        return type;
    }

    public void setType(ReferenceType type) {
        this.type = type;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Definition getDefinition() {
        return definition;
    }

    public void setDefinition(Definition definition) {
        this.definition = definition;
    }

    public String getReference() {
        return reference;
    }

    public void setReference(String reference) {
        this.reference = reference;
    }

    public String getAbbreviation() {
        return abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public ReferenceSourceType getSourceType() {
        return sourceType;
    }

    public void setSourceType(ReferenceSourceType sourceType) {
        this.sourceType = sourceType;
    }

    public IsActive getIsActive() {
        return isActive;
    }

    public void setIsActive(IsActive isActive) {
        this.isActive = isActive;
    }

    public Instant getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Instant createdAt) {
        this.createdAt = createdAt;
    }

    public Instant getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Instant updatedAt) {
        this.updatedAt = updatedAt;
    }

    public List<DmpReference> getDmpReferences() {
        return dmpReferences;
    }

    public void setDmpReferences(List<DmpReference> dmpReferences) {
        this.dmpReferences = dmpReferences;
    }

    public UserFileModel getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(UserFileModel createdBy) {
        this.createdBy = createdBy;
    }

    public String getHash() {
        return hash;
    }

    public void setHash(String hash) {
        this.hash = hash;
    }
}
