package eu.eudat.file.transformer.model.descriptiontemplatedefinition.fielddata;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import eu.eudat.file.transformer.enums.FieldType;

@JsonTypeInfo(
		use = JsonTypeInfo.Id.NAME,
		include = JsonTypeInfo.As.PROPERTY,
		property = "fieldType",
		visible = true)
@JsonSubTypes({
		@JsonSubTypes.Type(value = AutoCompleteData.class, name = FieldType.Names.Autocomplete),
		@JsonSubTypes.Type(value = BooleanDecisionData.class, name = FieldType.Names.BooleanDecision),
		@JsonSubTypes.Type(value = DatasetAutoCompleteData.class, name = FieldType.Names.InternalDmpDatasets),
		@JsonSubTypes.Type(value = DmpAutoCompleteData.class, name = FieldType.Names.InternalDmpDmps),
		@JsonSubTypes.Type(value = CheckBoxData.class, name = FieldType.Names.CheckBox),
		@JsonSubTypes.Type(value = DatePickerData.class, name = FieldType.Names.DatePicker),
		@JsonSubTypes.Type(value = ExternalDatasetData.class, name = FieldType.Names.ExternalDatasets),
		@JsonSubTypes.Type(value = FreeTextData.class, name = FieldType.Names.FreeText),
		@JsonSubTypes.Type(value = LicenseData.class, name = FieldType.Names.Licenses),
		@JsonSubTypes.Type(value = OrganizationData.class, name = FieldType.Names.Organizations),
		@JsonSubTypes.Type(value = PublicationData.class, name = FieldType.Names.Publications),
		@JsonSubTypes.Type(value = RadioBoxData.class, name = FieldType.Names.RadioBox),
		@JsonSubTypes.Type(value = RegistryData.class, name = FieldType.Names.Registries),
		@JsonSubTypes.Type(value = ResearcherAutoCompleteData.class, name = FieldType.Names.InternalDmpResearchers),
		@JsonSubTypes.Type(value = ResearcherData.class, name = FieldType.Names.Researchers),
		@JsonSubTypes.Type(value = RichTextAreaData.class, name = FieldType.Names.RichTextarea),
		@JsonSubTypes.Type(value = ServiceData.class, name = FieldType.Names.Services),
		@JsonSubTypes.Type(value = TagData.class, name = FieldType.Names.Tags),
		@JsonSubTypes.Type(value = TaxonomyData.class, name = FieldType.Names.Taxonomies),
		@JsonSubTypes.Type(value = TextAreaData.class, name = FieldType.Names.TextArea),
		@JsonSubTypes.Type(value = UploadData.class, name = FieldType.Names.Upload),
		@JsonSubTypes.Type(value = ValidationData.class, name = FieldType.Names.Validation),
		@JsonSubTypes.Type(value = DatasetIdentifierData.class, name = FieldType.Names.DatasetIdentifier),
		@JsonSubTypes.Type(value = CurrencyData.class, name = FieldType.Names.Currency),
		@JsonSubTypes.Type(value = WordListData.class, name = FieldType.Names.Wordlist),
		@JsonSubTypes.Type(value = DataRepositoryData.class, name = FieldType.Names.DataRepositories),
		@JsonSubTypes.Type(value = JournalRepositoryData.class, name = FieldType.Names.JournalRepositories),
		@JsonSubTypes.Type(value = PublicationRepositoryData.class, name = FieldType.Names.Publications),
})
public abstract class BaseFieldData {

	public final static String _label = "label";
	private String label;

	public final static String _fieldType = "fieldType";
	private FieldType fieldType;

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public FieldType getFieldType() {
		return fieldType;
	}

	public void setFieldType(FieldType fieldType) {
		this.fieldType = fieldType;
	}
}
